<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>HexPlot: /home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/fit_functions.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>/home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/utils/fit_functions.h</h1><a href="fit__functions_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00007"></a>00007 <span class="preprocessor">#ifndef FIT_FUNCTIONS_H</span>
<a name="l00008"></a>00008 <span class="preprocessor"></span><span class="preprocessor">#define FIT_FUNCTIONS_H</span>
<a name="l00009"></a>00009 <span class="preprocessor"></span>
<a name="l00010"></a>00010 <span class="preprocessor">#include &lt;TMath.h&gt;</span>
<a name="l00011"></a>00011 
<a name="l00012"></a>00012 <span class="preprocessor">#include &quot;<a class="code" href="cpp__utils_8h.html" title="A collection of C++ helper functions.">cpp_utils.h</a>&quot;</span>
<a name="l00013"></a>00013 
<a name="l00015"></a>00015 <span class="comment">// elementary functions</span>
<a name="l00017"></a>00017 <span class="comment"></span><span class="keyword">inline</span> <span class="keyword">static</span> Double_t mylandau(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00018"></a>00018   <span class="comment">// par[0] ~ normalization, par[1] ~ mean, par[2] broadness</span>
<a name="l00019"></a>00019   <span class="keywordflow">return</span> par[0] * (TMath::Landau(x[0], par[1], par[2]) / par[2]);
<a name="l00020"></a>00020 }
<a name="l00021"></a>00021 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t invlandau(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00022"></a>00022   <span class="comment">// par[0] ~ normalization, par[1] ~ mean, par[2] broadness</span>
<a name="l00023"></a>00023   <span class="keywordflow">return</span> par[0] * (TMath::Landau(-x[0], par[1], par[2]) / par[2]);
<a name="l00024"></a>00024 }
<a name="l00025"></a>00025 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t signal(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00026"></a>00026   <span class="comment">// par[0] ~ normalization, par[1] ~ mean, par[2] width</span>
<a name="l00027"></a>00027   <span class="comment">// return par[0]*exp(-0.5*pow((x[0]-par[1])/par[2],2));</span>
<a name="l00028"></a>00028   <span class="keywordflow">return</span> par[0] * TMath::Gaus(x[0], par[1], par[2]);
<a name="l00029"></a>00029 }
<a name="l00030"></a>00030 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t poisson(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00031"></a>00031   <span class="comment">// par[0] ~ normalization, par[1] ~ max</span>
<a name="l00032"></a>00032   <span class="keywordflow">return</span> par[0] * (TMath::Poisson(x[0], par[1]));
<a name="l00033"></a>00033 }
<a name="l00034"></a>00034 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t linear(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00035"></a>00035   <span class="comment">// printf(&quot;Returning %.2f + %.2f*%.2f = %.2f\n&quot;,par[0], x[0],par[1],par[0] + x[0]*par[1]);</span>
<a name="l00036"></a>00036   <span class="keywordflow">return</span> par[0] + x[0] * par[1];
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t quadratic(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00039"></a>00039   <span class="comment">// printf(&quot;Returning %.2f + %.2f*%.2f = %.2f\n&quot;,par[0], x[0],par[1],par[0] + x[0]*par[1]);</span>
<a name="l00040"></a>00040   <span class="keywordflow">return</span> par[0] + x[0] * par[1] + x[0] * x[0] * par[2];
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t hinkley(Double_t* zz, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keywordtype">double</span> z = zz[0];
<a name="l00046"></a>00046   <span class="keywordtype">double</span> norm = par[0];
<a name="l00047"></a>00047   <span class="keywordtype">double</span> mx = par[1];
<a name="l00048"></a>00048   <span class="keywordtype">double</span> sx = par[2];
<a name="l00049"></a>00049   <span class="keywordtype">double</span> my = par[3];
<a name="l00050"></a>00050   <span class="keywordtype">double</span> sy = par[4];   <span class="comment">// par[3]</span>
<a name="l00051"></a>00051   <span class="keywordtype">double</span> rho = par[5];  <span class="comment">// par[4]</span>
<a name="l00052"></a>00052   <span class="keywordtype">double</span> onemr2 = 1.0 - pow(rho, 2);
<a name="l00053"></a>00053   <span class="keywordtype">double</span> sonemr2 = sqrt(onemr2);
<a name="l00054"></a>00054   <span class="keywordtype">double</span> a = sqrt(pow(z / sx, 2) - 2.0 * rho * z / (sx * sy) + 1.0 / pow(sy, 2));
<a name="l00055"></a>00055   <span class="keywordtype">double</span> b = mx * z / pow(sx, 2) - rho * (mx + my * z) / (sx * sy) + my / pow(sy, 2);
<a name="l00056"></a>00056   <span class="keywordtype">double</span> c = pow(mx / sx, 2) - 2.0 * rho * mx * my / (sx * sy) + pow(my / sy, 2);
<a name="l00057"></a>00057   <span class="keywordtype">double</span> d = exp((pow(b, 2) - c * pow(a, 2)) / (2.0 * onemr2 * pow(a, 2)));
<a name="l00058"></a>00058   <span class="keywordtype">double</span> pi = TMath::Pi();
<a name="l00059"></a>00059   <span class="keywordtype">double</span> result = norm * (b * d / (pow(a, 3) * sqrt(2.0 * pi) * sx * sy) * TMath::Erf(b / (sonemr2 * a)) +
<a name="l00060"></a>00060                           sonemr2 / (pow(a, 2) * pi * sx * sy) * exp(-c / (2.0 * onemr2)));
<a name="l00061"></a>00061   <span class="keywordflow">return</span> result;
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t cryball(Double_t* z, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// Crystal Ball function</span>
<a name="l00067"></a>00067   <span class="comment">// Gaussian: N = normalisation, m = mean, s = sigma</span>
<a name="l00068"></a>00068   <span class="comment">// Tail:     a = boundary in sigma between gaussian and tail, n = relative hight of tail</span>
<a name="l00069"></a>00069   <span class="keywordtype">double</span> x = -z[0];
<a name="l00070"></a>00070   <span class="keywordtype">double</span> N = par[0];
<a name="l00071"></a>00071   <span class="keywordtype">double</span> m = -par[1];
<a name="l00072"></a>00072   <span class="keywordtype">double</span> s = par[2];
<a name="l00073"></a>00073   <span class="keywordtype">double</span> a = par[3];
<a name="l00074"></a>00074   <span class="keywordtype">double</span> n = par[4];
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordtype">double</span> A = pow(n / fabs(a), n) * exp(-pow(a, 2) / 2);
<a name="l00077"></a>00077   <span class="keywordtype">double</span> B = n / fabs(a) - fabs(a);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordtype">double</span> result = 0;
<a name="l00080"></a>00080   <span class="keywordflow">if</span> ((x - m) / s &gt; -a) {
<a name="l00081"></a>00081     result = N * exp(-pow(x - m, 2) / (2 * pow(s, 2)));
<a name="l00082"></a>00082   } <span class="keywordflow">else</span> {
<a name="l00083"></a>00083     result = N * A * pow(B - (x - m) / s, -n);
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="keywordflow">return</span> result;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">double</span> Novosibirsk(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00090"></a>00090   <span class="keywordtype">double</span> peak = par[0];
<a name="l00091"></a>00091   <span class="keywordtype">double</span> width = par[1];
<a name="l00092"></a>00092   <span class="keywordtype">double</span> tail = par[2];
<a name="l00093"></a>00093   <span class="comment">/*</span>
<a name="l00094"></a>00094 <span class="comment">  double sqrtln4 = sqrt(TMath::Log(4));</span>
<a name="l00095"></a>00095 <span class="comment">  double q = 1+((tail*(x[0]-peak)/sigma)*TMath::SinH(tail*sqrtln4)/tail*sqrtln4);</span>
<a name="l00096"></a>00096 <span class="comment">  double novo = TMath::Exp(pow(-0.5, pow(TMath::Log(q),2)/pow(tail,2)+pow(tail,2)));</span>
<a name="l00097"></a>00097 <span class="comment">  return novo;</span>
<a name="l00098"></a>00098 <span class="comment">  */</span>
<a name="l00099"></a>00099   <span class="comment">// from http://root.cern.ch/root/html/src/RooNovosibirsk.cxx.html#ZTLfhD</span>
<a name="l00100"></a>00100   <span class="comment">// see also : http://pprc.qmul.ac.uk/~bevan/afit/afit.pdf</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordtype">double</span> qa = 0, qb = 0, qc = 0, qx = 0, qy = 0;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (TMath::Abs(tail) &lt; 1.e-7) {
<a name="l00105"></a>00105     qc = 0.5 * TMath::Power(((x[0] - peak) / width), 2);
<a name="l00106"></a>00106   } <span class="keywordflow">else</span> {
<a name="l00107"></a>00107     qa = tail * sqrt(log(4.));
<a name="l00108"></a>00108     qb = sinh(qa) / qa;
<a name="l00109"></a>00109     qx = (x[0] - peak) / width * qb;
<a name="l00110"></a>00110     qy = 1. + tail * qx;
<a name="l00111"></a>00111     <span class="comment">//---- Cutting curve from right side</span>
<a name="l00112"></a>00112     <span class="keywordflow">if</span> (qy &gt; 1.E-7) {
<a name="l00113"></a>00113       qc = 0.5 * (TMath::Power((log(qy) / tail), 2) + tail * tail);
<a name="l00114"></a>00114     } <span class="keywordflow">else</span> {
<a name="l00115"></a>00115       qc = 15.0;
<a name="l00116"></a>00116     }
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118   <span class="comment">//---- Normalize the result</span>
<a name="l00119"></a>00119   <span class="keywordflow">return</span> exp(-qc);
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 <span class="keyword">inline</span> <span class="keyword">static</span> <span class="keywordtype">double</span> fit_function_asymmgauss(<span class="keywordtype">double</span>* x, <span class="keywordtype">double</span>* par)  <span class="comment">// NOLINT</span>
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   <span class="keywordtype">double</span> X = x[0];
<a name="l00124"></a>00124   <span class="keywordtype">double</span> Mean = par[1];
<a name="l00125"></a>00125   <span class="keywordtype">double</span> SigmaLeft = par[2];
<a name="l00126"></a>00126   <span class="keywordtype">double</span> SigmaRight = par[3];  <span class="comment">// SigmaLeft*1.3; //</span>
<a name="l00127"></a>00127   <span class="keywordtype">double</span> Sigma = (Mean &lt; X) ? SigmaLeft : SigmaRight;
<a name="l00128"></a>00128   <span class="keywordflow">return</span> par[0] * TMath::Gaus(X, Mean, Sigma);
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t gammadistr(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00131"></a>00131   <span class="comment">// par[0] = normalization, par[1]=gamma - shape parameter, par[2]=mu - location parameter, par[3]=beta  - scale</span>
<a name="l00132"></a>00132   <span class="comment">// parameter</span>
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (par[1] &lt; 0 || x[0] &lt; par[2] || par[3] &lt; 0) {
<a name="l00134"></a>00134     <span class="keywordflow">return</span> 0;
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136   { <span class="keywordflow">return</span> par[0] * TMath::GammaDist(x[0], par[1], par[2], par[3]); }
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t weibull(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00139"></a>00139   <span class="comment">// par[0]=norm,par[1]=x-offset,par[2]=x-scaling,par[3]=form parameter</span>
<a name="l00140"></a>00140   <span class="keywordtype">double</span> N = par[0];
<a name="l00141"></a>00141   <span class="keywordtype">double</span> xoffset = par[1];
<a name="l00142"></a>00142   <span class="keywordtype">double</span> xscale = par[2];
<a name="l00143"></a>00143   <span class="keywordtype">double</span> k = par[3];
<a name="l00144"></a>00144   <span class="keywordtype">double</span> X = (x[0] - xoffset) / xscale;
<a name="l00145"></a>00145   <span class="keywordtype">double</span> value = N * pow(X, k - 1) * exp(-pow(X, k));
<a name="l00146"></a>00146   <span class="keywordflow">return</span> value;
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t rayleigh(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00149"></a>00149   <span class="comment">// par[0]=norm,par[1]=x-offset,par[2]=x-scaling,par[3]=scaling parameter,par[4]=form parameter</span>
<a name="l00150"></a>00150   <span class="keywordtype">double</span> X = (x[0] - par[1]) / par[2];
<a name="l00151"></a>00151   <span class="keywordtype">double</span> s = par[3];
<a name="l00152"></a>00152   <span class="keywordtype">double</span> value = X / pow(s, 2) * exp(-pow(X, 2) / (2 * pow(s, 2)));
<a name="l00153"></a>00153   <span class="keywordflow">return</span> par[0] * value;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00157"></a>00157 <span class="comment">// composite functions</span>
<a name="l00159"></a>00159 <span class="comment"></span>
<a name="l00160"></a>00160 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_langauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00161"></a>00161   <span class="keywordtype">double</span> value = signal(x, par) + mylandau(x, &amp;par[3]);
<a name="l00162"></a>00162   <span class="keywordflow">return</span> positive(value);
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_doublegauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00165"></a>00165   <span class="keywordtype">double</span> value = signal(x, par) + signal(x, &amp;par[3]);
<a name="l00166"></a>00166   <span class="keywordflow">return</span> positive(value);
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_hinklan(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00169"></a>00169   <span class="keywordtype">double</span> value = hinkley(x, par) + mylandau(x, &amp;par[6]);
<a name="l00170"></a>00170   <span class="keywordflow">return</span> positive(value);
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_poigauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00173"></a>00173   <span class="keywordtype">double</span> value = signal(x, par) + poisson(x, &amp;par[3]);
<a name="l00174"></a>00174   <span class="keywordflow">return</span> positive(value);
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_lanpoiss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00177"></a>00177   <span class="keywordtype">double</span> value = mylandau(x, par) + poisson(x, &amp;par[3]);
<a name="l00178"></a>00178   <span class="keywordflow">return</span> positive(value);
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_hinkpoi(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00181"></a>00181   <span class="keywordtype">double</span> value = hinkley(x, par) + poisson(x, &amp;par[6]);
<a name="l00182"></a>00182   <span class="keywordflow">return</span> positive(value);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_cryballgauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00185"></a>00185   <span class="keywordtype">double</span> value = cryball(x, par) + signal(x, &amp;par[5]);
<a name="l00186"></a>00186   <span class="keywordflow">return</span> positive(value);
<a name="l00187"></a>00187 }
<a name="l00188"></a>00188 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_cryballlandau(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00189"></a>00189   <span class="keywordtype">double</span> value = cryball(x, par) + mylandau(x, &amp;par[5]);
<a name="l00190"></a>00190   <span class="keywordflow">return</span> positive(value);
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_landoublegauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00193"></a>00193   <span class="comment">// double val= mylandau(x,par) + signal(x,&amp;par[3]) + signal(x,&amp;par[6]);</span>
<a name="l00194"></a>00194   <span class="comment">// retudrn val&gt;=0?val:0;</span>
<a name="l00195"></a>00195   <span class="keywordtype">double</span> value = mylandau(x, par) + signal(x, &amp;par[3]) + signal(x, &amp;par[6]);
<a name="l00196"></a>00196   <span class="keywordflow">return</span> positive(value);
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_triplegauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00199"></a>00199   <span class="keywordtype">double</span> value = signal(x, par) + signal(x, &amp;par[3]) + signal(x, &amp;par[6]);
<a name="l00200"></a>00200   <span class="keywordflow">return</span> positive(value);
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_cryballlinear(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00203"></a>00203   <span class="keywordtype">double</span> value = linear(x, par) + cryball(x, &amp;par[2]);
<a name="l00204"></a>00204   <span class="keywordflow">return</span> positive(value);
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_lanasymmgauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00207"></a>00207   <span class="keywordtype">double</span> value = mylandau(x, par) + fit_function_asymmgauss(x, &amp;par[3]);
<a name="l00208"></a>00208   <span class="keywordflow">return</span> positive(value);
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_doublelandau(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00211"></a>00211   <span class="keywordtype">double</span> value = mylandau(x, par) + mylandau(x, &amp;par[3]);
<a name="l00212"></a>00212   <span class="keywordflow">return</span> positive(value);
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_gaussasymmgauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00215"></a>00215   <span class="keywordtype">double</span> value = signal(x, par) + fit_function_asymmgauss(x, &amp;par[3]);
<a name="l00216"></a>00216   <span class="keywordflow">return</span> positive(value);
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_invlangauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00219"></a>00219   <span class="keywordtype">double</span> value = signal(x, par) + invlandau(x, &amp;par[3]);
<a name="l00220"></a>00220   <span class="keywordflow">return</span> positive(value);
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_gammagauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00223"></a>00223   <span class="keywordtype">double</span> value = gammadistr(x, par) + signal(x, &amp;par[4]);
<a name="l00224"></a>00224   <span class="keywordflow">return</span> positive(value);
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_gammalandau(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00227"></a>00227   <span class="keywordtype">double</span> value = gammadistr(x, par) + mylandau(x, &amp;par[4]);
<a name="l00228"></a>00228   <span class="keywordflow">return</span> positive(value);
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_gammalinear(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00231"></a>00231   <span class="keywordtype">double</span> value = gammadistr(x, par) + linear(x, &amp;par[4]);
<a name="l00232"></a>00232   <span class="keywordflow">return</span> positive(value);
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_weibull(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00235"></a>00235   <span class="keywordtype">double</span> value = weibull(x, par);
<a name="l00236"></a>00236   <span class="keywordflow">return</span> positive(value);
<a name="l00237"></a>00237 }
<a name="l00238"></a>00238 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_weibullgauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00239"></a>00239   <span class="keywordtype">double</span> value = weibull(x, par) + signal(x, &amp;par[4]);
<a name="l00240"></a>00240   <span class="keywordflow">return</span> positive(value);
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_invlandoublegauss(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00243"></a>00243   <span class="keywordtype">double</span> value = invlandau(x, par) + signal(x, &amp;par[3]) + signal(x, &amp;par[6]);
<a name="l00244"></a>00244   <span class="keywordflow">return</span> positive(value);
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_linearintersection(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00247"></a>00247   <span class="comment">// par[0] is the intersection point x0</span>
<a name="l00248"></a>00248   <span class="comment">// function is a + b*x when x &lt; x0</span>
<a name="l00249"></a>00249   <span class="comment">// and c + d*x when x &gt; x0</span>
<a name="l00250"></a>00250   <span class="comment">// par[] contains [x0, a, b, d]</span>
<a name="l00251"></a>00251   <span class="comment">// c is calculated as (a + b*x0) - d*x0</span>
<a name="l00252"></a>00252   <span class="keyword">auto</span>* par2 = <span class="keyword">new</span> <span class="keywordtype">double</span>[2];
<a name="l00253"></a>00253   par2[0] = linear(par, &amp;par[1]) - par[3] * par[0];
<a name="l00254"></a>00254   par2[1] = par[3];
<a name="l00255"></a>00255   <span class="keywordtype">double</span> value = x[0] &lt; par[0] ? linear(x, &amp;par[1]) : linear(x, par2);
<a name="l00256"></a>00256   <span class="keywordflow">return</span> value;
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t smoothed_linearintersection(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00260"></a>00260   <span class="comment">// same as linearintersection but with an extra parameter par[4] that controls smoothing</span>
<a name="l00261"></a>00261   <span class="keyword">auto</span>* par2 = <span class="keyword">new</span> <span class="keywordtype">double</span>[2];
<a name="l00262"></a>00262   par2[0] = linear(par, &amp;par[1]) - par[3] * par[0];
<a name="l00263"></a>00263   par2[1] = par[3];
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="keywordtype">double</span> k = par[4];
<a name="l00266"></a>00266   <span class="keywordtype">double</span> y0 = linear(x, &amp;par[1]);
<a name="l00267"></a>00267   <span class="keywordtype">double</span> y1 = linear(x, par2);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="comment">// define a smoothed minimum function, becomes a true minimum as k -&gt; 0</span>
<a name="l00270"></a>00270   <span class="keywordtype">double</span> value = std::pow(std::pow(std::abs(y0), -k) + std::pow(std::abs(y1), -k), -1 / k);
<a name="l00271"></a>00271   value = std::copysign(value, y0);  <span class="comment">// deal with y0 becoming negative, assume y1 cannot be</span>
<a name="l00272"></a>00272   <span class="keywordflow">return</span> value;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="keyword">inline</span> <span class="keyword">static</span> Double_t fit_function_quadlinearintersection(Double_t* x, Double_t* par) {  <span class="comment">// NOLINT</span>
<a name="l00276"></a>00276   <span class="comment">// par[0] is the intersection point x0</span>
<a name="l00277"></a>00277   <span class="comment">// function is a + b*x - c*x*x when x &lt; x0</span>
<a name="l00278"></a>00278   <span class="comment">// and d + e*x when x &gt; x0</span>
<a name="l00279"></a>00279   <span class="comment">// par[] contains [x0, a, b, c, e]</span>
<a name="l00280"></a>00280   <span class="comment">// d is calculated as (a + b*x0 - c*x0*x0) - e*x0</span>
<a name="l00281"></a>00281   <span class="keyword">auto</span>* par2 = <span class="keyword">new</span> <span class="keywordtype">double</span>[2];
<a name="l00282"></a>00282   par2[0] = (par[1] + par[0] * par[1] - par[0] * par[0] * par[2]) - par[4] * par[0];
<a name="l00283"></a>00283   par2[1] = par[4];
<a name="l00284"></a>00284   <span class="keywordtype">double</span> value = x[0] &lt; par[0] ? (par[1] + x[0] * par[1] - x[0] * x[0] * par[2]) : linear(x, par2);
<a name="l00285"></a>00285   <span class="keywordflow">return</span> value;
<a name="l00286"></a>00286 }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="preprocessor">#endif</span>
</pre></div></div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 29 May 2020 for HexPlot by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
